// Rewriten by Michal Husak 2001 husakm@vscht.cz

/*
 *		This Code Was Created By Lionel Brits & Jeff Molofee 2000
 *		A HUGE Thanks To Fredric Echols For Cleaning Up
 *		And Optimizing The Base Code, Making It More Flexible!
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit My Site At nehe.gamedev.net
 */

#include <windows.h>		// Header File For Windows
#include <math.h>			// Math Library Header File
#include <stdio.h>			// Header File For Standard Input/Output
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
//#include <gl\glaux.h>		// Header File For The Glaux Library
#include "glut\glut.h"
#include <float.h> // float number limits

//	Michal Husak stereoscopy modification
#include "stereoscopic_projection.h"
#include "interlace_stencil.h"

// Michal Husak VFX3D
#include "VFXsdk.h"
#include "dialog.h"
#include "resource.h"
#include "MCE_VR.h"
#include "log.h"
#include "mcube_bourke.h"
#include "midi.h"
#include "voxel_procesing.h"
#include "molecular_objects.h"
#include "atom_procesing.h"

// Michal Husak fps calulation
#include <time.h>

long yaw, pitch, roll;		// headtracking results
GLint g_current_width, g_current_height; // get global acces to the window dimension

// Michal Husak modification
// joystick function (for Cybar Puck)

MMRESULT joyResult;
JOYINFO joy;

MceVrConfiguration Conf;
MceVrMode	Mode;
BOOL g_bMakeSound=FALSE;
int g_i_period=500; // sound period in ms

// displaylists symbolic names
// RESERVED = 0 , non correct name !!!
typedef enum {RESERVED,CUBE,LINEOBJECT,MCE_TRIANGLES,MCE_CONTOURS,MESH} displayLists;

GLfloat lookuproll = 0.0f;
GLfloat starting_speed =0.2f; // initial speed
GLfloat speed =0.2f; // current speed
float cross_z_distance=5; // ditanc to the manipulation cross ,shuld corespond to stereo settings
GLfloat scale=1; // speed multiplaing coef

// end of Michal Husak VFX3D


HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	blend;				// Blending ON/OFF
bool	bp;					// B Pressed?
bool	fp;					// F Pressed?
bool	op;					// O Pressed?

const float piover180 = 0.0174532925f;
float heading;
float xpos=0; // starting point
float zpos=10;
float ypos=0;
float aspect;				// global acces to the display ratio

GLfloat	yrot;				// Y Rotation
GLfloat walkbias = 0;
GLfloat walkbiasangle = 0;
GLfloat lookupdown = 0.0f;

GLuint	filter;				// Which Filter To Use
GLuint	texture[3];			// Storage For 3 Textures

typedef struct tagSHOT_PARAMETERS
{
	float startx, starty, startz;
	float heading,lookupdown;
	bool active;
} SHOT_PARAMETERS;

// ELD map data structures
ELD_MapData MapData;
StructureDescription MolData;

// triangle field
static unsigned int g_iNtriangles[3];
static TRIANGLE triangles[3][MAXTRIANGLES];

// line controur field
static unsigned int g_iNcontourlines[3];
static LINE	contourlines[3][MAXCONTOURLINES];

static float layer_limits[3];
#define START 0.1
#define STEP 0.2

// graphic effects parameters
static XYZ mark;
static SHOT_PARAMETERS shot;
static float shot_intensity=0;
static float shot_maximum=0;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

void readstr(FILE *f,char *string)
{
	do
	{
		fgets(string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));
	return;
}

void ReadFouFile()
{
	FILE *filein;
	char oneline[255];
	// debuging
#ifdef _DEBUG
	char szBuffer[256];
#endif

	// support variable
	int nLineNumber=0;
	int i, j;
	int x,y,z;
	int atom_record_lenght;


	filein = fopen(Conf.szFileName, "rt");				// File To Load World Data From

//	filein = fopen("data/test.fou", "rt");				// File To Load World Data From

	readstr(filein,oneline); //INFO DOWN, ....?
	readstr(filein,oneline); //TRAN ?

	for (i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			readstr(filein,oneline);
			MapData.PlaneMatrix[i][j]=(float) atof(oneline);
#ifdef _DEBUG
			sprintf(szBuffer,"%d %d %f \n",i,j,MapData.PlaneMatrix[i][j]);
			LogMsg(szBuffer);
#endif
		}
	}
	
	for (i=0;i<3;i++)
	{
		readstr(filein,oneline);
		MapData.PlaneTranslation[i]=(float) atof(oneline);
	}

	readstr(filein,oneline); // CELL

	for (i=0;i<6;i++)
	{
		readstr(filein,oneline);
		MapData.Cell[i]=(float) atof(oneline);
	}

	readstr(filein,oneline); // L14

	for (i=0;i<3;i++)
	{
		readstr(filein,oneline);
		MapData.AxisParam[i].Start=(float) atof(oneline);

		readstr(filein,oneline);
		MapData.AxisParam[i].Step=(float) atof(oneline);

		readstr(filein,oneline);
		MapData.AxisParam[i].End=(float) atof(oneline);

		readstr(filein,oneline);
		MapData.AxisParam[i].Division=(float) atof(oneline);
	}

	readstr(filein,oneline); // SIZE

	readstr(filein,oneline);
	MapData.Lines=atoi(oneline);

	readstr(filein,oneline);
	MapData.Columns=atoi(oneline);

	readstr(filein,oneline);
	MapData.Sections=atoi(oneline);

	// !!! This parto of the code is not memory-optimal !!!
	// ReDim Voxel(MapData.Lines, MapData.Columns, MapData.Sections)

	for (z=0;z<MapData.Sections;z++)
	{
		readstr(filein,oneline); // BLOCK
		readstr(filein,oneline); // N

#ifdef _DEBUG
			sprintf(szBuffer,"Z layer: %d Values: %s\n",z,oneline);
			LogMsg(szBuffer);
#endif

		for(x=0;x<MapData.Lines;x++)
		{
			for(y=0;y<MapData.Columns;y++)
			{
				readstr(filein,oneline);
				MapData.Voxel[x][y][z]=(float) atof(oneline);
			}
		}
	}

	// mlecular data input

	readstr(filein,oneline); //LIST5

	readstr(filein,oneline);
	MolData.Natoms=atoi(oneline);

	if (MolData.Natoms>0)
	{
		readstr(filein,oneline);
		atom_record_lenght=atoi(oneline);
		for (i=0;i<MolData.Natoms;i++)
		{
			readstr(filein,oneline); // atom name
			strncpy(MolData.a[i].name,oneline,2);

			readstr(filein,oneline);
			MolData.a[i].atm_label_number=atoi(oneline);

			readstr(filein,oneline);
			MolData.a[i].occ=(float) atof(oneline);

			readstr(filein,oneline); // reserved, dummy now

			readstr(filein,oneline);
			MolData.a[i].fc.x=(float) atof(oneline);

			readstr(filein,oneline);
			MolData.a[i].fc.y=(float) atof(oneline);

			readstr(filein,oneline);
			MolData.a[i].fc.z=(float) atof(oneline);
			
			readstr(filein,oneline);
			MolData.a[i].uiso=(float) atof(oneline);
			
			for(j=0;j<6;j++)
			{
				readstr(filein,oneline);
				MolData.a[i].u[j]=(float) atof(oneline);
			}

			// dumy data from future fou versions
			if (atom_record_lenght>14)
			{
				for(j=15;j<=atom_record_lenght;j++)
				{
					readstr(filein,oneline); // dummy reading
				}
			}
		}// next j
	} // endif atom presents

	fclose(filein);
}

XYZ triangle_center(XYZ p0,XYZ p1, XYZ p2)
{
	XYZ result ;

	result.x=(p0.x+p1.x+p2.x)/3;
	result.y=(p0.y+p1.y+p2.y)/3;
	result.z=(p0.z+p1.z+p2.z)/3;

	return result;
}

	


void GenerateDisplayLists()
{
	unsigned long i;
	XYZ center;
	// MCE line object generation

	//typedef enum tagGridType {MSquare_XYZ,MSquare_Z,MSquare_XZ,MCube_Triangle,MCube_Web}

	
	switch(Mode.GridType)
	{
	case MCube_Triangle:

	glNewList(MESH, GL_COMPILE);
		glColor3f (0.0f, 1.0f, 0.0f); // green lines
		for (i=0;i<g_iNtriangles[0];i++)
		{
			glBegin(GL_LINE_LOOP);
				glVertex3f(triangles[0][i].p[0].x,triangles[0][i].p[0].y,triangles[0][i].p[0].z);
				glVertex3f(triangles[0][i].p[1].x,triangles[0][i].p[1].y,triangles[0][i].p[1].z);
				glVertex3f(triangles[0][i].p[2].x,triangles[0][i].p[2].y,triangles[0][i].p[2].z);
			glEnd();
		}
		glColor3f (0.0f, 0.0f, 1.0f); // blue lines
		for (i=0;i<g_iNtriangles[1];i++)
		{
			glBegin(GL_LINE_LOOP);
				glVertex3f(triangles[1][i].p[0].x,triangles[1][i].p[0].y,triangles[1][i].p[0].z);
				glVertex3f(triangles[1][i].p[1].x,triangles[1][i].p[1].y,triangles[1][i].p[1].z);
				glVertex3f(triangles[1][i].p[2].x,triangles[1][i].p[2].y,triangles[1][i].p[2].z);
			glEnd();
		}
		glColor3f (1.0f, 0.0f, 0.0f); // red lines
		for (i=0;i<g_iNtriangles[2];i++)
		{
			glBegin(GL_LINE_LOOP);
				glVertex3f(triangles[2][i].p[0].x,triangles[2][i].p[0].y,triangles[2][i].p[0].z);
				glVertex3f(triangles[2][i].p[1].x,triangles[2][i].p[1].y,triangles[2][i].p[1].z);
				glVertex3f(triangles[2][i].p[2].x,triangles[2][i].p[2].y,triangles[2][i].p[2].z);
			glEnd();
		}
	glEndList();
	break;

	case MCube_Web:
	glNewList(MESH, GL_COMPILE);
		glBegin(GL_LINES);
		glColor3f (0.0f, 1.0f, 0.0f); // green lines
		for (i=0;i<g_iNtriangles[0];i++)
		{
			center=triangle_center(triangles[0][i].p[0],triangles[0][i].p[1],triangles[0][i].p[2]);

			glVertex3f(triangles[0][i].p[0].x,triangles[0][i].p[0].y,triangles[0][i].p[0].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[0][i].p[1].x,triangles[0][i].p[1].y,triangles[0][i].p[1].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[0][i].p[2].x,triangles[0][i].p[2].y,triangles[0][i].p[2].z);
			glVertex3f(center.x,center.y,center.z);
		}
		glColor3f (0.0f, 0.0f, 1.0f); // blue lines
		for (i=0;i<g_iNtriangles[1];i++)
		{
			center=triangle_center(triangles[1][i].p[0],triangles[1][i].p[1],triangles[1][i].p[2]);

			glVertex3f(triangles[1][i].p[0].x,triangles[1][i].p[0].y,triangles[1][i].p[0].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[1][i].p[1].x,triangles[1][i].p[1].y,triangles[1][i].p[1].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[1][i].p[2].x,triangles[1][i].p[2].y,triangles[1][i].p[2].z);
			glVertex3f(center.x,center.y,center.z);
		}
		glColor3f (1.0f, 0.0f, 0.0f); // red lines
		for (i=0;i<g_iNtriangles[2];i++)
		{
			center=triangle_center(triangles[2][i].p[0],triangles[2][i].p[1],triangles[2][i].p[2]);

			glVertex3f(triangles[2][i].p[0].x,triangles[2][i].p[0].y,triangles[2][i].p[0].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[2][i].p[1].x,triangles[2][i].p[1].y,triangles[2][i].p[1].z);
			glVertex3f(center.x,center.y,center.z);
			glVertex3f(triangles[2][i].p[2].x,triangles[2][i].p[2].y,triangles[2][i].p[2].z);
			glVertex3f(center.x,center.y,center.z);
		}
		glEnd();
	glEndList();
	break;

	case MSquare_XYZ:
	case MSquare_Z:
	case MSquare_XZ:
	// line controur generation
	glNewList(MESH, GL_COMPILE);
		glBegin(GL_LINES);
		glColor3f (0.0f, 1.0f, 0.0f); // green lines
		for (i=0;i<g_iNcontourlines[0];i++)
		{			
				glVertex3f(contourlines[0][i].p[0].x,contourlines[0][i].p[0].y,contourlines[0][i].p[0].z);
				glVertex3f(contourlines[0][i].p[1].x,contourlines[0][i].p[1].y,contourlines[0][i].p[1].z);
		}
		glColor3f (0.0f, 0.0f, 1.0f); // blue lines
		for (i=0;i<g_iNcontourlines[1];i++)
		{
				glVertex3f(contourlines[1][i].p[0].x,contourlines[1][i].p[0].y,contourlines[1][i].p[0].z);
				glVertex3f(contourlines[1][i].p[1].x,contourlines[1][i].p[1].y,contourlines[1][i].p[1].z);
		}
		glColor3f (1.0f, 0.0f, 0.0f); // red lines
		for (i=0;i<g_iNcontourlines[2];i++)
		{
				glVertex3f(contourlines[2][i].p[0].x,contourlines[2][i].p[0].y,contourlines[2][i].p[0].z);
				glVertex3f(contourlines[2][i].p[1].x,contourlines[2][i].p[1].y,contourlines[2][i].p[1].z);
		}
		glEnd();
	glEndList();
	break;
	} // end switch
}

void GenerateMesh()
{
	int i;

#ifdef _DEBUG
	LogMsg("Mesh generation\n");
#endif

	// initiliaze the number of graphic element values
	for(i=0;i<=2;i++)
	{
		g_iNcontourlines[i]=0;
		g_iNtriangles[i]=0;
	}
	
	switch(Mode.GridType)
	{
		case MSquare_XYZ:
		{
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,X);
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,Y);
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,Z);
//LogMsg("Z mesh generation finished\n");
		}
		break;

		case MSquare_Z:
		{
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,Z);
		}
		break;

		case MSquare_XZ:
		{
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,X);
			VoxelDirectionalContour(&g_iNcontourlines[0],&MapData,layer_limits,contourlines,Z);
		}
		break;

		case MCube_Triangle:
		{
			GenerateTrianglesFromVoxels(&g_iNtriangles[0],&MapData,layer_limits,triangles);
		}
		break;

		case MCube_Web:
		{
			GenerateTrianglesFromVoxels(&g_iNtriangles[0],&MapData,layer_limits,triangles);
		}
		break;	
	}
#ifdef _DEBUG
	LogMsg("Mesh generation completly finished\n");
#endif
}


float distance (XYZ p1, XYZ p2)
{
// simple distance of two points

float d1,d2,d3;

	d1=p1.x-p2.x;
	d2=p1.y-p2.y;
	d3=p1.z-p2.z;

return sqrt(d1*d1+d2*d2+d3*d3);

}

void SetupConectivity()
{
 int i, j;
 float blenght;

 MolData.bond.nBond=0;

 for(i=0; i<MolData.Natoms; i++)
 {
	 for(j=i+1; j<MolData.Natoms;j++)
	 {
		 blenght=distance(MolData.a[i].cc,MolData.a[j].cc);

		 // shuld be replaced by property table int the future
		 if((strcmp(MolData.a[i].name,"H ")==0) | (strcmp(MolData.a[j].name,"H ")==0))
		 {
			if((blenght>0.7)&&(blenght<1.2)) // new atom
			{
				MolData.bond.nIndex[MolData.bond.nBond][0]=i;
				MolData.bond.nIndex[MolData.bond.nBond][1]=j;
				MolData.bond.nBond=MolData.bond.nBond++;
			}
		 }
		 else if((blenght>0.7)&&(blenght<1.65)) // new atom
		 {		
			MolData.bond.nIndex[MolData.bond.nBond][0]=i;
			MolData.bond.nIndex[MolData.bond.nBond][1]=j;
			MolData.bond.nBond=MolData.bond.nBond++;
		 }
	
	 } // next j
 }

}

void SetupWorld()
{
	ReadFouFile();

	StuctureToCart(&MolData,&MapData);

	SetupConectivity();

	SetLayerLimits(START,STEP,&layer_limits[0],&MapData);

	GenerateMesh();

	GenerateDisplayLists();
	ActivateMidi();

	//MidiOutMessage (0xC0,  0, 46, 0) ;// Send Program Change messages for "sci-fi"

	// Program Change for Drum
	MidiOutMessage (0xC0,  9,0, 0) ;
	MidiOutMessage (0xC0,  0,0, 0) ;

	
	// Other pre-setting

	// mark setup
	mark.x=0;
	mark.y=0;
	mark.z=0;
	//mark.z= -cross_z_distance ;
}


GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	g_current_width=width;
	g_current_height=height;
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	if(Mode.ActualDisplayMode==StereoInterlaced)
	{
		interlace_stencil_horizontal(width,height);
	}

	if(Mode.ActualDisplayMode==StereoVertical)
	{
		interlace_stencil_vertical(width,height);
	}

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	aspect =(GLfloat)width/(GLfloat)height;	
}

void InitGLLighting()
{
	GLfloat light_position[]={1.0,1.0,1.0,0.0};

	glLightfv(GL_LIGHT0,GL_POSITION,light_position);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Set The Blending Function For Translucency
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// This Will Clear The Background Color To Black
	glClearDepth(1.0);									// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);								// The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glShadeModel(GL_SMOOTH);							// Enables Smooth Color Shading
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glEnable (GL_COLOR_MATERIAL);						// color surfaces of materials

	InitGLLighting();

	return TRUE;										// Initialization Went OK
}

bool TestOpenGlError(const char * szMessage)
{
	GLenum errCode;
	const GLubyte *errString;
	char szBuffer[256];

		// OpenGl error examination
	if((errCode= glGetError())!=GL_NO_ERROR)
	{
		errString=gluErrorString(errCode);
		sprintf(szBuffer,"OpenGl Error: %s\n Error location: %s",errString,szMessage);	
		MessageBox(NULL,szBuffer,"OpenGL Error",MB_ICONERROR);
		return false;
	}
	else
	{
		return true;
	}
}

void Camera(eye mode)
{
	float viewing_angle=45.0f; // colud regulat the scene scale
//	float viewing_angle_current; // for scaling experiments
	float near_clip_plane=0.1f;
	float far_clip_plane=100.0f;
	float half_angl_tng=(float)tan((viewing_angle/2.f)*piover180); // suport variable for the recalculation
	float shift=half_angl_tng*near_clip_plane;
	// for stereoscopy
	float dist = 5; // distance from center of projection to zeroplane
	float eye = dist/30;

	
	// experiments
	/*
	viewing_angle_current=viewing_angle*scale;

	half_angl_tng=(float)tan((viewing_angle_current/2.f)*piover180); // suport variable for the recalculation
	shift=half_angl_tng*near_clip_plane;
	*/


	switch (mode)
	{
		case CentralEyePicking:
			//stereo_projection_picking(-a * stretchX, a * stretchX, -a * stretchY, a * stretchY, z, -z, 0, dist, 0); 
		break;

		case CentralEye:
			// different ways to do the same thing

			// standard way
			//gluPerspective(viewing_angle,aspect,near_clip_plane,far_clip_plane);

			// ekvivalent to gluPerspecitve by glFrustrum
			// glFrustum(-aspect*shift,aspect*shift,-shift,shift,near_clip_plane,far_clip_plane);

			// ekvivalent in stereo projection	
			// stereo_projection(xmin,xmax,ymin,ymax,znear,zfar,zzps,dist,eye)
			stereo_projection(-half_angl_tng*dist* aspect,
						half_angl_tng*dist* aspect,
						-half_angl_tng*dist, half_angl_tng*dist,
						-near_clip_plane, -far_clip_plane,
						-dist, dist, 0);
		break;

		case LeftEye:
			stereo_projection(-half_angl_tng*dist* aspect,
						half_angl_tng*dist* aspect,
						-half_angl_tng*dist, half_angl_tng*dist,
						-near_clip_plane, -far_clip_plane,
						-dist, dist, -eye);
		break;

		case RightEye:
			stereo_projection(-half_angl_tng*dist* aspect,
						half_angl_tng*dist* aspect,
						-half_angl_tng*dist, half_angl_tng*dist,
						-near_clip_plane, -far_clip_plane,
						-dist, dist, +eye);
		break;
	}    

}


void recalcModelView()
{
	glMatrixMode(GL_MODELVIEW);

	glLoadIdentity();	// Reset The View

	GLfloat xtrans = -xpos;
	GLfloat ztrans = -zpos;
	GLfloat ytrans = -ypos;
//	GLfloat ytrans = -walkbias-0.25f-ypos; // walkibias disabled
	GLfloat sceneroty = 360.0f - yrot;

	// aditonal roll for VFX3D by Michal Husak
	glRotatef(lookuproll,0,0,1.0f);
	glRotatef(lookupdown,1.0f,0,0);
	glRotatef(sceneroty,0,1.0f,0);


	glTranslatef(xtrans, ytrans, ztrans);
	
//	glScalef(scale,scale,scale);
}


// calcluate map intensity in given point
float Intensity(float x,float y,float z)
{
	float intensity;
	int ix,iy,iz;
	int xmax,ymax,zmax;
	XYZ voxel_pos;

	xmax=MapData.Lines;
	ymax=MapData.Columns;
	zmax=MapData.Sections;

	voxel_pos=Coord3DfToInd(x,y,z,&MapData);
	
	ix=(int)(voxel_pos.x+0.5);
	iy=(int)(voxel_pos.y+0.5);
	iz=(int)(voxel_pos.z+0.5);
	
	/*
	ix=(int)(x);
	iy=(int)(y);
	iz=(int)(z);
	*/


	if ((ix>=0) & (iy>=0) & (iz >=0) & (ix<=xmax) & (iy<=ymax) & (iz<=zmax))
	{

		intensity=MapData.Voxel[ix][iy][iz];
	}
	else
	{
		intensity=-10000;
	}

	return intensity;
}


void Shot()
{
	float size=1.0f;
	static float distance=0;
	const float distancemax=20;
	static GLUquadricObj *quadObj2=NULL;
	float x,y,z;
	static float hit_x,hit_y,hit_z;
	static float maximum_hit =FLT_MIN ;

	// sphere matereial
	GLfloat mat_specular[]={1.0,1.0,1.0,1.0};
	GLfloat mat_shiness[]={50.0};

	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT,GL_SHININESS,mat_shiness);

	glColor3f(1,0,1); // yelow sphere
	
  // sphere 
	if (! quadObj2)
	{
		quadObj2 = gluNewQuadric();
		//object properties (invisible if not defined !)
		//type of filling LINE,FILL
		gluQuadricDrawStyle (quadObj2, GLU_FILL);
		//type of shading - SMOOTH,FLAT
		gluQuadricNormals (quadObj2, GLU_SMOOTH);
		//vektors INSIDE OUTSIDE - for light calculations ??
		gluQuadricOrientation (quadObj2, GLU_OUTSIDE);
	}

	if(shot.active)
	{
		if(distance < distancemax)
		{
			distance=distance+0.2f;
			// the mark is in cross_z_distance distance in the navigation cross direction ....
			x =shot.startx-(float)sin((90-shot.lookupdown)*piover180)*(float)sin(shot.heading*piover180) * distance;
			z =shot.startz-(float)sin((90-shot.lookupdown)*piover180)*(float)cos(shot.heading*piover180) * distance;
			y =shot.starty-(float)cos((90-shot.lookupdown)*piover180)* distance;

			glPushMatrix();
				glTranslatef(x,y,z);
				gluSphere (quadObj2, 0.2 ,8,8);
			glPopMatrix();

			shot_intensity=Intensity(x,y,z);
			if(shot_intensity>maximum_hit)
			{
				maximum_hit=shot_intensity;
				hit_x=x;
				hit_y=y;
				hit_z=z;
			}
		}
		else
		{
			distance=0;
			shot.active=FALSE;

			if (maximum_hit> FLT_MIN)
			{
				// put the mark in the maximum intensity found in the hit
				mark.x = hit_x;
				mark.y = hit_y;
				mark.z = hit_z;
				PlaySound("Notify.wav",NULL,SND_FILENAME  );
				shot_maximum=maximum_hit;
			}

			maximum_hit =FLT_MIN;
		}
	}
}

void Mark()
{
	float size=1.0f;
	static int flash_count =0;
	int switch_count=5;
	static GLUquadricObj *quadObj=NULL;

	// sphere matereial
	GLfloat mat_specular[]={1.0,1.0,1.0,1.0};
	GLfloat mat_shiness[]={50.0};
	
// mark point
	glDisable(GL_LIGHTING);
	if (flash_count<switch_count)
	{
		glBegin(GL_LINES);
			glColor3f(1,0,1); // X
			glVertex3f(mark.x-size,mark.y,mark.z);
			glVertex3f(mark.x+size,mark.y,mark.z);
		glEnd();

		glBegin(GL_LINES);
			glColor3f(1,1,0); // Y
			glVertex3f(mark.x,mark.y-size,mark.z);
			glVertex3f(mark.x,mark.y+size,mark.z);
		glEnd();
		glBegin(GL_LINES);
			glColor3f(1,0,1); // Z
			glVertex3f(mark.x,mark.y,mark.z+size);
			glVertex3f(mark.x,mark.y,mark.z-size);
		glEnd();		
	}
	if (flash_count>switch_count)
	{
		glBegin(GL_LINES);
			glColor3f(1,1,0); // X
			glVertex3f(mark.x-size,mark.y,mark.z);
			glVertex3f(mark.x+size,mark.y,mark.z);
		glEnd();

		glBegin(GL_LINES);
			glColor3f(0,1,1); // Y 
			glVertex3f(mark.x,mark.y-size,mark.z);
			glVertex3f(mark.x,mark.y+size,mark.z);
		glEnd();
		glBegin(GL_LINES);
			glColor3f(1,1,0); // Z 
			glVertex3f(mark.x,mark.y,mark.z+size);
			glVertex3f(mark.x,mark.y,mark.z-size);
		glEnd();
	}

	if (flash_count<(2*switch_count))
	{
		flash_count++;
	}	
	else
	{
		flash_count=0;
	}

	glEnable(GL_LIGHTING);
  // sphere 

	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT,GL_SHININESS,mat_shiness);

	glColor3f(1,1,0); // yelow sphere

	if (! quadObj)
	{
		quadObj = gluNewQuadric();
		//object properties (invisible if not defined !)
		//type of filling LINE,FILL
		gluQuadricDrawStyle (quadObj, GLU_FILL);
		//type of shading - SMOOTH,FLAT
		gluQuadricNormals (quadObj, GLU_SMOOTH);
		//vektors INSIDE OUTSIDE - for light calculations ??
		gluQuadricOrientation (quadObj, GLU_OUTSIDE);
	}

  glPushMatrix();
	glTranslatef(mark.x,mark.y,mark.z);
	gluSphere (quadObj, 0.2 ,8,8);
  glPopMatrix();
}

static void printstring(void *font, char *string)
{
  int len,i;

  len=(int)strlen(string);
  for(i=0;i<len;i++)
    glutBitmapCharacter(font,string[i]);
}

void SetTextStart(RECT rect,int screen_height,int font_shift, int font_step, int line)
{
	glRasterPos2i(rect.left+5,screen_height-(rect.top+font_shift+line*font_step));
}
void RenderOSD()
{
	char szBuffer[256];
	float x,y,z;
	float intensity;
	static int tone;
	static int delay=0;
	static int chanel=0;
	// fps calulation
	static time_t start_time=0;
	static time_t current_time=0;
	static time_t count_time=4; // fps updated after X sec
	static int frames_count=0;
	static float fps=0;
	static void *font_type=GLUT_BITMAP_9_BY_15;
	RECT osd_rect;
	int font_step,font_shift;
	GLboolean bDepthTest;

	// setting OSD parameters
	if ((Mode.Control==VFX3D_cyberpuck) | (Mode.Control==VFX3D_keyboard) | (Mode.Control==VFX3D_joypad))
	{ // big font for VFX3D
		font_type=GLUT_BITMAP_TIMES_ROMAN_24;
		osd_rect.left=15;
		osd_rect.right=230;
		osd_rect.top=15;
		osd_rect.bottom=270;
		font_shift=20;
		font_step=30;
	}
	else
	{
		font_type=GLUT_BITMAP_9_BY_15;
		osd_rect.left=10;
		osd_rect.right=230;
		osd_rect.top=10;
		osd_rect.bottom=190;
		font_step=20;
		font_shift=10;
	}
	


	// the mark is in cross_z_distance distance in the navigation cross direction ....
	x =xpos-(float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * cross_z_distance;
	z =zpos-(float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * cross_z_distance;
	y =ypos-(float)cos((90-lookupdown)*piover180)* cross_z_distance;

	intensity=Intensity(x,y,z);


	glViewport(0,0,g_current_width,g_current_height);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0,g_current_width,0.0,g_current_height-1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	// drawing area
	glEnable(GL_BLEND);
	glColor4f(0.35,0.35,0.4,0.5);
	glRecti(osd_rect.left,g_current_height-osd_rect.top,osd_rect.right,g_current_height-osd_rect.bottom);
	glDisable(GL_BLEND);

	glGetBooleanv(GL_DEPTH_TEST,&bDepthTest);
	glDisable(GL_DEPTH_TEST);

	glColor3f(1.0,1.0,0.0);

	SetTextStart(osd_rect,g_current_height,font_shift,font_step,0);
	printstring(font_type,"Cross position");

	sprintf(szBuffer,"X: %7.2f",x);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,1);
	printstring(font_type,szBuffer);
	
	sprintf(szBuffer,"Y: %7.2f",y);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,2);
	printstring(font_type,szBuffer); 

	sprintf(szBuffer,"Z: %7.2f",z);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,3);
	printstring(font_type,szBuffer); 

	sprintf(szBuffer,"I: %7.2f",intensity);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,4);
	printstring(font_type,szBuffer);
	
	if (shot.active)
	{
		glColor3f(1.0,0.0,1.0);
		sprintf(szBuffer,"Shot I: %7.2f",shot_intensity);
		SetTextStart(osd_rect,g_current_height,font_shift,font_step,5);
		printstring(font_type,szBuffer);
	}
	else
	{
		glColor3f(1.0,0.0,1.0);
		sprintf(szBuffer,"Shot M: %7.2f",shot_maximum);
		SetTextStart(osd_rect,g_current_height,font_shift,font_step,5);
		printstring(font_type,szBuffer);
	}

	// fps calulation

	time( &current_time);
	frames_count ++;
	if ((current_time - start_time) > count_time)
	{
		start_time=current_time;
		fps= (float)frames_count/(float)count_time;
		frames_count=0;
	}

	glColor3f(1.0,1.0,0.0);
	sprintf(szBuffer,"FPS: %7.2f",fps);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,6);
	printstring(font_type,szBuffer);

	glColor3f(1.0,1.0,0.0);
	sprintf(szBuffer,"Speed mult: %7.2f",scale);
	SetTextStart(osd_rect,g_current_height,font_shift,font_step,7);
	printstring(font_type,szBuffer);
	
	// set depth test back to original value
	if(bDepthTest) glEnable(GL_DEPTH_TEST);
}

void RenderAudio()
{
float x,y,z;
float intensity;
	
	// the mark is in cross_z_distance distance in the navigation cross direction ....
	x =xpos-(float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * cross_z_distance;
	z =zpos-(float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * cross_z_distance;
	y =ypos-(float)cos((90-lookupdown)*piover180)* cross_z_distance;

	intensity=Intensity(x,y,z);

	// sound info

	// where you are (hearing sound on cursor position sounds stupid
	//  intensity=Intensity(xpos,ypos,zpos); 
	if (intensity > 0)
	{
		g_bMakeSound=TRUE;
		g_i_period=(int) 1000 * (1/(1+intensity*0.3));
	}

	else
	{		
		g_bMakeSound=FALSE;
	}
}

void SetAtomColor(char name[2])
{
	if (strcmp(name,"C ")==0)
	{
		glColor3f(0.7,0.7,0.7); // gray
	}

	else if (strcmp(name,"H ")==0)
	{
		glColor3f(0.7,0.7,1.0); // light blue
	}

	else if (strcmp(name,"N ")==0)
	{
		glColor3f(0,0,0.8); // blue
	}

	else if (strcmp(name,"O ")==0)
	{
		glColor3f(0.8,0,0); // red
	}

	else if (strcmp(name,"S ")==0)
	{
		glColor3f(0.8,0.8,0); // yellow
	}

	else
	{
		glColor3f(0.4,0.4,0.4); // dark gray
	}
}


void DrawAtoms()
{
	int i;

	static GLUquadricObj *quadObj3=NULL;

	// sphere matereial
	GLfloat mat_specular[]={1.0,1.0,1.0,1.0};
	GLfloat mat_shiness[]={50.0};

	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT,GL_SHININESS,mat_shiness);
	
  // sphere 
	if (! quadObj3)
	{
		quadObj3 = gluNewQuadric();
		//object properties (invisible if not defined !)
		//type of filling LINE,FILL
		gluQuadricDrawStyle (quadObj3, GLU_FILL);
		//type of shading - SMOOTH,FLAT
		gluQuadricNormals (quadObj3, GLU_SMOOTH);
		//vektors INSIDE OUTSIDE - for light calculations ??
		gluQuadricOrientation (quadObj3, GLU_OUTSIDE);
	}
	
	glEnable(GL_LIGHTING);

	for(i=0;i<MolData.Natoms;i++)
	{
	glPushMatrix();

		SetAtomColor(MolData.a[i].name);

		glTranslatef(MolData.a[i].cc.x,
					 MolData.a[i].cc.y,
				     MolData.a[i].cc.z);

		// shuld be replaced by radius table in the future ...
		
		if (strcmp(MolData.a[i].name,"H ")==0)
		{
			gluSphere (quadObj3, 0.1 ,8,8);
		}
		else
		{
			gluSphere (quadObj3, 0.2 ,8,8);
		}

	glPopMatrix();
	}
}

void DrawBonds()
{
	int i;
	int i1;
	int i2;

	glColor3f(1,1,1); // white lines for bonds

	glBegin(GL_LINES);

	for(i=0;i<MolData.bond.nBond;i++)
	{
		i1=MolData.bond.nIndex[i][0];
		i2=MolData.bond.nIndex[i][1];

		glVertex3f(MolData.a[i1].cc.x,MolData.a[i1].cc.y,MolData.a[i1].cc.z);
		glVertex3f(MolData.a[i2].cc.x,MolData.a[i2].cc.y,MolData.a[i2].cc.z);
	}

	glEnd();
}

void RenderScene()
{
	glEnable(GL_LIGHTING);
	Mark();
	Shot();
	DrawAtoms();

	glDisable(GL_LIGHTING);
	DrawBonds();
	glCallList(MESH);

	if(Mode.OSD_visible)
	{
		RenderOSD();
	}
	RenderAudio();
}

void NavigationCross()
{
float size=0.5;

static GLfloat rot_angle=0;

rot_angle+=1;

if (rot_angle > 360) rot_angle =0;

	glMatrixMode(GL_MODELVIEW);

	glDisable(GL_LIGHTING);
	glLoadIdentity();
	glTranslatef(0,0,-cross_z_distance);
	glRotatef(rot_angle,1,1,1);
	glBegin(GL_LINES);
		glColor4f(1,1,1,1);
		glVertex3f(-size,0,0);
		glVertex3f(size,0,0);
		glVertex3f(0,-size,0);
		glVertex3f(0,size,0);
		glVertex3f(0,0,+size);
		glVertex3f(0,0,-size);
	glEnd();
	glEnable(GL_LIGHTING);
}

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{

	switch (Mode.ActualDisplayMode)
	{
		case NoStereo:
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glLineWidth(Mode.LineWidth); // nesesery for ticknes lost
			Camera(CentralEye);			
			NavigationCross();
			recalcModelView();
			RenderScene();
			glFinish();
			TestOpenGlError("OnDraw - NoStero");
			SwapBuffers(hDC);					// Swap Buffers (Double Buffering)

		break;

		case StereoHW:

			//Left Image
			glDrawBuffer (GL_BACK_LEFT);
			glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glLineWidth(Mode.LineWidth); // nesesery for ticknes lost

			Camera(LeftEye);
			NavigationCross();
	        recalcModelView();
			RenderScene();
        
			// Right Image
			glDrawBuffer (GL_BACK_RIGHT);
			glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			Camera (RightEye);
			NavigationCross();
			recalcModelView();
			RenderScene();
			glFinish();
			TestOpenGlError("OnDraw - SteroHW");
			SwapBuffers(hDC);					// Swap Buffers (Double Buffering)

		break;

		// horizontal and vertical stereoscopy
		// difer in stencil pattern only
		case StereoInterlaced: 
		case StereoVertical:
    
			glEnable (GL_STENCIL_TEST);
			glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
            glLineWidth(2*Mode.LineWidth); // nesesery for ticknes lost during interlacing

			//Left Image
			glStencilFunc (GL_NOTEQUAL, 1, 1); // draws if stencil <> 1
			Camera (LeftEye);
			NavigationCross();
			recalcModelView();
			RenderScene();
			        
			//Right Image
			glStencilFunc (GL_EQUAL, 1, 1); // draws if stencil <> 0
			Camera (RightEye);
			NavigationCross();
			recalcModelView();
			RenderScene();
			
			glFinish();
			TestOpenGlError("OnDraw - SteroInterlaced");
			SwapBuffers(hDC);					// Swap Buffers (Double Buffering)        
		break;
	}

	return TRUE;										// Everything Went OK
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (Mode.fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, BOOL fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	Mode.fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (Mode.fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				Mode.fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (Mode.fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	DWORD dwFlags;
	int iStencil;
			
	switch (Mode.ActualDisplayMode)
	{
		case NoStereo:
			dwFlags =
			PFD_DRAW_TO_WINDOW |	// support window
			PFD_SUPPORT_OPENGL |	// support OpenGL
			PFD_DOUBLEBUFFER ;		// double buffered
			iStencil =0;			// stencil buffer not required	
		break;

		case StereoHW:
			dwFlags =
			PFD_DRAW_TO_WINDOW |	// support window
			PFD_SUPPORT_OPENGL |	// support OpenGL
			PFD_STEREO |			// activate stereoscopic mode
			PFD_DOUBLEBUFFER ;		// double buffered
			iStencil =0;			// stencil buffer not required
		break;

		case StereoInterlaced:
		case StereoVertical:
			dwFlags =
			PFD_DRAW_TO_WINDOW |	// support window
			PFD_SUPPORT_OPENGL |	// support OpenGL
			PFD_DOUBLEBUFFER ;		// double buffered        
			iStencil =1;			// stencil buffer not required
		break;
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		dwFlags,									// Mode
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		iStencil,									// Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
#define ID_TIMER    1
{
	switch (uMsg)		// Check For Windows Messages
	{
		case WM_CREATE:
		{
			SetTimer (hWnd, ID_TIMER, 500, NULL) ;
          return 0 ;
		}

		case WM_TIMER:
		{
			if(g_bMakeSound)
			{
				// normal sound MidiOutMessage (0x90,0, 0x3C, 127) ;

				MidiOutMessage(0x90,  0, 62, 0); // drumm
				MidiOutMessage(0x90,  9, 62, 125);

				SetTimer (hWnd, ID_TIMER, g_i_period, NULL) ;
			}
			else
			{
				MidiOutMessage(0x90,  0, 62, 0); // drumm
				// normal sound MidiOutMessage (0x90,0, 0x3C, 0) ;
			}

			return 0;
		}

		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
				keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}	
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void SetDefaultConf()
{
	FILE *filein;
	char oneline[255];
	char code[255];
	
	filein = fopen("data/mce_vr.cfg", "rt");
	
	// default setting

	Conf.OutputResolutionCode=RES_WINDOWED;
	Conf.BppCode=RES_16_BPP;
	Conf.VisualisationMode=IDC_MODE_MONO;
	Conf.ControlMode=IDC_CONTROL_KEYBOARD;
	Conf.JoysticDeviceNumber=IDC_JOY1;
	Conf.LineWidthCode=IDC_LINE1;
	Conf.OSD_mode=IDC_OSD_YES;
	Conf.GridSelection=IDC_M_SQUARE_XYZ;
	sprintf(Conf.szFileName,"%s","data/test1.fou");

	if (filein==NULL)
	{
		MessageBox(NULL,"MCE_VR.CFG not found, using default configuration.","Warning",MB_ICONERROR);
	}
	else
	{			
		// interpreting MCE_VR.CFG file
		readstr(filein,oneline);
		sscanf(oneline, "OutputResolutionCode %s\n", code);
		if (strstr(code,"RES_WINDOWED")) Conf.OutputResolutionCode=RES_WINDOWED;
		if (strstr(code,"RES_640_480")) Conf.OutputResolutionCode=RES_640_480;
		if (strstr(code,"RES_800_600")) Conf.OutputResolutionCode=RES_800_600;
		if (strstr(code,"RES_1024_768")) Conf.OutputResolutionCode=RES_1024_768;
		if (strstr(code,"RES_1152_864")) Conf.OutputResolutionCode=RES_1152_864;

		readstr(filein,oneline);
		sscanf(oneline, "BppCode %s\n", code);
		if (strstr(code,"RES_16_BPP")) Conf.BppCode=RES_16_BPP;
		if (strstr(code,"RES_24_BPP")) Conf.BppCode=RES_24_BPP;
		if (strstr(code,"RES_32_BPP")) Conf.BppCode=RES_32_BPP;

		readstr(filein,oneline);
		sscanf(oneline, "VisualisationMode %s\n", code);
		if (strstr(code,"IDC_MODE_MONO")) Conf.VisualisationMode=IDC_MODE_MONO;
		if (strstr(code,"IDC_MODE_STEREO_HW")) Conf.VisualisationMode=IDC_MODE_STEREO_HW;
		if (strstr(code,"IDC_MODE_STEREO_INTERLACED")) Conf.VisualisationMode=IDC_MODE_STEREO_INTERLACED;
		if (strstr(code,"IDC_MODE_STEREO_VERTICAL")) Conf.VisualisationMode=IDC_MODE_STEREO_VERTICAL;

		
		readstr(filein,oneline);
		sscanf(oneline, "ControlMode %s\n", code);
		if (strstr(code,"IDC_CONTROL_KEYBOARD")) Conf.ControlMode=IDC_CONTROL_KEYBOARD;
		if (strstr(code,"IDC_CONTROL_JOYSTICK")) Conf.ControlMode=IDC_CONTROL_JOYSTICK;
		if (strstr(code,"IDC_CONTROL_VFX3D_KEYBOARD")) Conf.ControlMode=IDC_CONTROL_VFX3D_KEYBOARD;
		if (strstr(code,"IDC_CONTROL_VFX3D_CYBERPUCK")) Conf.ControlMode=IDC_CONTROL_VFX3D_CYBERPUCK;
		if (strstr(code,"IDC_CONTROL_VFX3D_JOYPAD")) Conf.ControlMode=IDC_CONTROL_VFX3D_JOYPAD;
		
		readstr(filein,oneline);
		sscanf(oneline, "JoysticDeviceNumber %s\n", code);
		if (strstr(code,"IDC_JOY1")) Conf.JoysticDeviceNumber=IDC_JOY1;
		if (strstr(code,"IDC_JOY2")) Conf.JoysticDeviceNumber=IDC_JOY2;
	
		readstr(filein,oneline);
		sscanf(oneline, "LineWidthCode %s\n", code);
		if (strstr(code,"IDC_LINE1")) 	Conf.LineWidthCode=IDC_LINE1;
		if (strstr(code,"IDC_LINE2")) 	Conf.LineWidthCode=IDC_LINE2;
		if (strstr(code,"IDC_LINE3")) 	Conf.LineWidthCode=IDC_LINE3;
	
		readstr(filein,oneline);
		sscanf(oneline, "OSD_mode %s\n", code);
		if (strstr(code,"IDC_OSD_YES")) Conf.OSD_mode=IDC_OSD_YES;
		if (strstr(code,"IDC_OSD_NO")) 	Conf.LineWidthCode=IDC_OSD_NO;
	
		readstr(filein,oneline);
		sscanf(oneline, "GridSelection %s\n", code);
		if (strstr(code,"IDC_M_SQUARE_XYZ")) Conf.GridSelection=IDC_M_SQUARE_XYZ;
		if (strstr(code,"IDC_M_SQUARE_Z")) Conf.GridSelection=IDC_M_SQUARE_Z;
		if (strstr(code,"IDC_M_SQUARE_XZ")) Conf.GridSelection=IDC_M_SQUARE_XZ;
		if (strstr(code,"IDC_M_CUBE_TRIANGLE")) Conf.GridSelection=IDC_M_CUBE_TRIANGLE;
		if (strstr(code,"IDC_M_CUBE_WEB")) Conf.GridSelection=IDC_M_CUBE_WEB;

		fclose(filein);
	}
}


void SetMode()
{
	// Setup of the resolution
	if (Conf.OutputResolutionCode==RES_WINDOWED)
	{
		Mode.fullscreen=FALSE;							// Windowed Mode
		Mode.OutputWidth=640;
		Mode.OutputHeight=480;
		Mode.OutputBpp=16;
	}
	else
	{
		Mode.fullscreen=TRUE;

		switch(Conf.OutputResolutionCode)
		{
		case RES_640_480:
			Mode.OutputWidth=640;
			Mode.OutputHeight=480;
			
		break;
			case RES_800_600:
			Mode.OutputWidth=800;
			Mode.OutputHeight=600;
		break;
		case RES_1024_768:
			Mode.OutputWidth=1024;
			Mode.OutputHeight=768;
		break;
		case RES_1152_864:
			Mode.OutputWidth=1152;
			Mode.OutputHeight=864;
		break;
		}
	

		switch(Conf.BppCode)
		{	
			case RES_16_BPP:			
				Mode.OutputBpp=16;
			break;
			case RES_24_BPP:			
				Mode.OutputBpp=24;
			break;
			case RES_32_BPP:			
				Mode.OutputBpp=32;
			break;
		}	
	}

	// Tranlate joydevice identification
	switch	(Conf.JoysticDeviceNumber)
	{
		case IDC_JOY1:

			Mode.JoystickDevIdentification=JOYSTICKID1;

		break;

		case IDC_JOY2:

			Mode.JoystickDevIdentification=JOYSTICKID2;

		break;
	}

	// Setup and activate the control devices
	
	switch(Conf.ControlMode)
	{
		case IDC_CONTROL_KEYBOARD:

			Mode.Control=Keyboard;

		break;

		case IDC_CONTROL_JOYSTICK:

			joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

			if (joyResult == JOYERR_NOERROR  )
			{
				Mode.Control=Joystick;			
			}
			else
			{
				MessageBox(NULL,"Joystick device failure, Keyboard control only","Warning",MB_ICONERROR);
				Mode.Control=Keyboard;
			}

		break;

			
		case IDC_CONTROL_VFX3D_KEYBOARD:
			if ( VFXLoadDll() == VFX_OK)
			{
				Mode.Control=VFX3D_keyboard;
			}
			else
			{
				MessageBox(NULL,"VFX3D drivers not detected, Keyboard control only","Warning",MB_ICONERROR);
				Mode.Control=Keyboard;
			}		
		break;

		case IDC_CONTROL_VFX3D_CYBERPUCK:

			joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

			if ( VFXLoadDll() == VFX_OK)
			{
				if(joyResult == JOYERR_NOERROR)
				{
					Mode.Control=VFX3D_cyberpuck;
				}
				else
				{
					MessageBox(NULL,"Cyberpuck failure, VFX3D + Keyboard control only","Warning",MB_ICONERROR);
					Mode.Control=VFX3D_keyboard;
				}
			}
			else
			{
				MessageBox(NULL,"VFX3D drivers not detected, Keyboard control only","Warning",MB_ICONERROR);
				Mode.Control=Keyboard;
			}		
		break;

		case IDC_CONTROL_VFX3D_JOYPAD:

			joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

			if ( VFXLoadDll() == VFX_OK)
			{
				if(joyResult == JOYERR_NOERROR)
				{
					Mode.Control=VFX3D_joypad;
				}
				else
				{
					MessageBox(NULL,"Joypad failure, VFX3D + Keyboard control only","Warning",MB_ICONERROR);
					Mode.Control=VFX3D_keyboard;
				}
			}
			else
			{
				MessageBox(NULL,"VFX3D drivers not detected, Keyboard control only","Warning",MB_ICONERROR);
				Mode.Control=Keyboard;
			}		
		break;

	}
	
	switch (Conf.VisualisationMode)
	{
		case IDC_MODE_MONO: 
			Mode.ActualDisplayMode=NoStereo;
		break;

		case IDC_MODE_STEREO_HW: 
			Mode.ActualDisplayMode=StereoHW;
			// make VFX3D manual stereo mode control possible
			if ((Mode.Control==VFX3D_cyberpuck) | (Mode.Control==VFX3D_keyboard) | (Mode.Control==VFX3D_joypad))
			{
				VFXSetVideoMode(VFX_OVERRIDE);
				//VFXSetVideoMode(VFX_DIRECTX);
			}
		break;

		case IDC_MODE_STEREO_INTERLACED: 
			Mode.ActualDisplayMode=StereoInterlaced;
			// make VFX3D manual stereo mode control possible
			if ((Mode.Control==VFX3D_cyberpuck) | (Mode.Control==VFX3D_keyboard) | (Mode.Control==VFX3D_joypad))
			{
				VFXSetVideoMode(VFX_OVERRIDE);
				//VFXSetVideoMode(VFX_DIRECTX);
			}
		break;

		case IDC_MODE_STEREO_VERTICAL: 
			Mode.ActualDisplayMode=StereoVertical;			
		break;
	}

	switch(Conf.LineWidthCode)
	{
		case IDC_LINE1:
			Mode.LineWidth=1;
		break;
		case IDC_LINE2:
			Mode.LineWidth=2;
		break;
		case IDC_LINE3:
			Mode.LineWidth=3;
		break;
	}

	// translate OSD mode

	if (Conf.OSD_mode==IDC_OSD_YES)
	{
		Mode.OSD_visible=TRUE;
	}
	else
	{
		Mode.OSD_visible=FALSE;
	}
	
	switch(Conf.GridSelection)
	{
		case IDC_M_SQUARE_XYZ:
			Mode.GridType=MSquare_XYZ;
		break;
		case IDC_M_SQUARE_Z:
			Mode.GridType=MSquare_Z;
		break;
		case IDC_M_SQUARE_XZ:
			Mode.GridType=MSquare_XZ;
		break;
		case IDC_M_CUBE_TRIANGLE:
			Mode.GridType=MCube_Triangle;
		break;
		case IDC_M_CUBE_WEB:
			Mode.GridType=MCube_Web;
		break;	
	}
}
void SetShot()
{
	if(!shot.active)
	{
		shot.active=TRUE;
		shot.heading=heading;
		shot.lookupdown=lookupdown;
		shot.startx=xpos;
		shot.starty=ypos;
		shot.startz=zpos;
	}
}

void SetMark()
{
// the mark is in cross_z_distance distance in the navigation cross direction ....
mark.x =xpos-(float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * cross_z_distance;
mark.z =zpos-(float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * cross_z_distance;
mark.y =ypos-(float)cos((90-lookupdown)*piover180)* cross_z_distance;

	PlaySound("Notify.wav",NULL,SND_FILENAME  );

}

void KeyboardControl()
{
static float zero=START;

speed=starting_speed*scale;

	if (keys[VK_RIGHT])
	{
		heading -= 1.0f;
		yrot = heading;
	}

	if (keys[VK_LEFT])
	{
		heading += 1.0f;	
		yrot = heading;
	}

	if (keys[VK_PRIOR])
	{
		lookupdown-= 1.0f;
	}

	if (keys[VK_NEXT])
	{
		lookupdown+= 1.0f;
	}

	if (keys[VK_UP])
	{
		// forward ( a bit modified polar coordinates)
		xpos -= (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * speed;
		zpos -= (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * speed;
		ypos -= (float)cos((90-lookupdown)*piover180)* speed;

		if (walkbiasangle >= 359.0f)
		{
			walkbiasangle = 0.0f;
		}
		else
		{
			walkbiasangle+= 10;
		}
		walkbias = (float)sin(walkbiasangle * piover180)/20.0f;
	}

	if (keys[VK_DOWN])
	{
		// backward ( a bit modified polar coordinates)
		xpos += (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * speed;
		zpos += (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * speed;
		ypos += (float)cos((90-lookupdown)*piover180)* speed;

		if (walkbiasangle <= 1.0f)
		{
			walkbiasangle = 359.0f;
		}
		else
		{
			walkbiasangle-= 10;
		}
		walkbias = (float)sin(walkbiasangle * piover180)/20.0f;
	}
	
	if (keys[VK_ADD])
	{
		if (zero<0.99)
		{
			zero=zero+0.01;
			SetLayerLimits(zero,STEP,&layer_limits[0],&MapData);
			GenerateMesh();
			glDeleteLists(MESH,1);
			GenerateDisplayLists();
		}
	}
	
	if (keys[VK_SUBTRACT])
	{
		if (zero>-0.99)
		{
			zero=zero-0.01;
			SetLayerLimits(zero,STEP,&layer_limits[0],&MapData);
			GenerateMesh();
			glDeleteLists(MESH,1);
			GenerateDisplayLists();
		}
	}
	
	if (keys['1'])
	{
	
		scale=scale*0.9;
	}

	if (keys['2'])
	{
	
		scale=scale*1.1;
	}

	if (keys['3'])
	{
	
		scale=1;
	}



}

void VFX3DControl()
{

	VFXGetTracking( &yaw, &pitch, &roll );
	// yaw in range 0 - 655535, horziontal direction
	// yaw 0 = -179.99 deg
	// yaw 32768 = 0 deg
	// yaw 65535 = 180.00 deg
	heading=(((float)yaw*360)/65535)-180;
	yrot=heading;
	// pitch range is 20025 - 45511, head up-down
	// pitch 45511 = 70 deg
	// pitch 20025 = -70 deg
	// it must be minus from some reason ??
	lookupdown=-(((float)pitch*360)/65535)-180;
					
	// roll shuld handled as pitch
	lookuproll=(((float)roll*360)/65535)-180;
}

void JoysticControl()
{
float actual_speed;

	joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

	if (joy.wYpos>40000)
	{	
		actual_speed=speed+5*speed*(joy.wYpos-40000)/20000;
		// forward ( a bit modified polar coordinates)
		xpos += (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * actual_speed;
		zpos += (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * actual_speed;
		ypos += (float)cos((90-lookupdown)*piover180)* actual_speed;
						
	}

	if (joy.wYpos<20000)
	{
		actual_speed=speed+5*speed*(20000-joy.wYpos)/20000;
		// backward
		xpos -= (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * actual_speed;
		zpos -= (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * actual_speed;
		ypos -= (float)cos((90-lookupdown)*piover180)* actual_speed;
	}

	if (joy.wXpos>40000)
	{	
		// left
		heading -= 1.0f;
		yrot = heading;
						
	}

	if (joy.wXpos<20000)
	{
		// right
		heading += 1.0f;
		yrot = heading;
	}

	if (joy.wButtons==JOY_BUTTON1)
	{
		lookupdown+= 1.0f;
	}

	if (joy.wButtons==JOY_BUTTON2)
	{
		lookupdown-= 1.0f;
	}

	if (joy.wButtons==JOY_BUTTON3)
	{					
		SetShot();				
	}

	if (joy.wButtons==JOY_BUTTON4)
	{					
		SetMark();				
	}
}

void CyberpuckControl()
{
	joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

	if (joy.wButtons==JOY_BUTTON2)
	{	
		// forward ( a bit modified polar coordinates)
		xpos -= (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * speed;
		zpos -= (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * speed;
		ypos -= (float)cos((90-lookupdown)*piover180)* speed;
				
	}

	if (joy.wButtons==JOY_BUTTON1)
	{
		// backward
		xpos += (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * speed;
		zpos += (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * speed;
		ypos += (float)cos((90-lookupdown)*piover180)* speed;
	}

	if (joy.wButtons==JOY_BUTTON3)
	{					
		SetShot();				
	}
}

void JoypadControl()
{
	static bool j1p=FALSE; // JOY1 pressed
	float actual_speed;
	static float zero=START;

	joyResult= joyGetPos(Mode.JoystickDevIdentification,&joy);

	if (joy.wYpos>40000)
	{	
		actual_speed=speed;//+5*speed*(joy.wYpos-40000)/20000;
		// forward ( a bit modified polar coordinates)
		xpos += (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * actual_speed;
		zpos += (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * actual_speed;
		ypos += (float)cos((90-lookupdown)*piover180)* actual_speed;
						
	}

	if (joy.wYpos<20000)
	{
		actual_speed=speed; //+5*speed*(20000-joy.wYpos)/20000;
		// backward
		xpos -= (float)sin((90-lookupdown)*piover180)*(float)sin(heading*piover180) * actual_speed;
		zpos -= (float)sin((90-lookupdown)*piover180)*(float)cos(heading*piover180) * actual_speed;
		ypos -= (float)cos((90-lookupdown)*piover180)* actual_speed;
	}

	// mesh control
	if (joy.wXpos>40000)
	{
		if(zero <0.99)
		{
			zero=zero+0.01;
			SetLayerLimits(zero,STEP,&layer_limits[0],&MapData);
			GenerateMesh();
			glDeleteLists(MESH,1);
			GenerateDisplayLists();
		}
	}
	
	if (joy.wXpos<20000)
	{
		if(zero >0.01)
		{
			zero=zero-0.01;
			SetLayerLimits(zero,STEP,&layer_limits[0],&MapData);
			GenerateMesh();
			glDeleteLists(MESH,1);
			GenerateDisplayLists();
		}
	}	
	
	if (joy.wButtons==JOY_BUTTON4 && !j1p)
	{	
		j1p=TRUE;
		Mode.OSD_visible=!Mode.OSD_visible;
	}
	if (joy.wButtons!=JOY_BUTTON4)
	{	
		j1p=FALSE;
	}

	if (joy.wButtons==JOY_BUTTON1)
	{
		SetShot();
	}

	if (joy.wButtons==JOY_BUTTON3)
	{					
		SetMark();				
	}

	if (joy.wButtons==JOY_BUTTON2)
	{	
		
		//restore layer limits
		SetLayerLimits(START,STEP,&layer_limits[0],&MapData);
		GenerateMesh();
		glDeleteLists(MESH,1);
		GenerateDisplayLists();
	}
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	SetDefaultConf();

	SetupDialog(hInstance,NULL,&Conf);

	SetMode();

	// Create Our OpenGL Window
	if (!CreateGLWindow("Michal Husak - Marching Cube VR",Mode.OutputWidth,Mode.OutputHeight,Mode.OutputBpp,Mode.fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	// Read the input data and generate display lists
	SetupWorld();

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			else									// Not Time To Quit, Update Screen
			{
				switch (Mode.Control)
				{
					case Keyboard:

						KeyboardControl();
						
					break;

					case Joystick:

						JoysticControl();

					break;

					case VFX3D_keyboard:

						VFX3DControl();
						KeyboardControl();
				
					break;

					case VFX3D_cyberpuck:

						VFX3DControl();
						CyberpuckControl();
						
					break;

					case VFX3D_joypad:

						VFX3DControl();
						JoypadControl();
					break;
				}
									

				if (keys['B'] && !bp)
				{
					bp=TRUE;
					blend=!blend;
					if (!blend)
					{
						glDisable(GL_BLEND);
						glEnable(GL_DEPTH_TEST);
					}
					else
					{
						glEnable(GL_BLEND);
						glDisable(GL_DEPTH_TEST);
					}
				}
				if (!keys['B'])
				{
					bp=FALSE;
				}

				if (keys['F'] && !fp)
				{
					fp=TRUE;
					filter+=1;
					if (filter>2)
					{
						filter=0;
					}
				}
				if (!keys['F'])
				{
					fp=FALSE;
				}

				// setting the mark
				if (keys['M'])
				{
					SetMark();
				}

				// setting the mark
				if (keys['S'])
				{
					SetShot();
				}

				if (keys['O'] && !op)
				{
					op=TRUE;
					Mode.OSD_visible=! Mode.OSD_visible;
				}
				if (!keys['O'])
				{
					op=FALSE;
				}
							
				if (keys[VK_F1])						// Is F1 Being Pressed?
				{
					keys[VK_F1]=FALSE;					// If So Make Key FALSE
					KillGLWindow();						// Kill Our Current Window
					Mode.fullscreen=!Mode.fullscreen;				// Toggle Fullscreen / Windowed Mode
					// Recreate Our OpenGL Window
					if (!CreateGLWindow("Lionel Brits & NeHe's 3D World Tutorial",Mode.OutputWidth,Mode.OutputHeight,Mode.OutputBpp,Mode.fullscreen))
					{
						return 0;						// Quit If Window Was Not Created
					}
				}
			}
		}
	}

	// Shutdown
	KillGLWindow();			// Kill The Window

	// Denitiliaizaion of the VFX3D Dll
	if ((Mode.Control==VFX3D_keyboard)|(Mode.Control==VFX3D_cyberpuck))
	{
		if ( VFXFreeDll() != VFX_OK)
		{
			MessageBox(NULL,"Unable to unload VFX3D drivers","Error",MB_ICONERROR);
			return 0;
		}
	}

	DeactivateMidi();

	return (msg.wParam);								// Exit The Program
}
