#include <windows.h>
#include "midi.h"

static BOOL bMidiActivated=FALSE;
static HMIDIOUT hMidiOut;

DWORD MidiOutMessage (int iStatus, int iChannel,int iData1,  int iData2)
{
DWORD result;

	if (bMidiActivated)
	{
     DWORD dwMessage = iStatus | iChannel | (iData1 << 8) | (iData2 << 16) ;
     
     result= midiOutShortMsg (hMidiOut, dwMessage) ;

		if (result != MMSYSERR_NOERROR)
		{
			MessageBox (NULL, TEXT ("MIDI device failure"),"Warning", MB_ICONEXCLAMATION | MB_OK) ;
		}

	return result;
	}
	else
	{
		return -1;
	}
}

BOOL ActivateMidi()
{
	 
   if (midiOutOpen (&hMidiOut, MIDIMAPPER, 0, 0, 0) != MMSYSERR_NOERROR )
   {
         MessageBeep (MB_ICONEXCLAMATION) ;
         MessageBox (NULL, TEXT ("Cannot open MIDI output device!"),"Warning", MB_ICONEXCLAMATION | MB_OK) ;
		 bMidiActivated=FALSE;
         return FALSE;
   }

   bMidiActivated=TRUE;
   return TRUE;
}

void DeactivateMidi()
{
	if (bMidiActivated)
	{
		midiOutReset (hMidiOut) ;
		midiOutClose (hMidiOut) ;
	}
}
