// (c) 2000 Michal Husak husakm@vscht.cz 
#ifndef __MOLECULAR_OBJECTS
	#define __MOLECULAR_OBJECTS
#include "geometrical_objects.h"

	#define MAXATOMS 5000
	#define MAXBONDS 6000

	typedef struct{
	char name[2]; // atom name
	XYZ fc; // fractional coordinates
	XYZ	cc;	// cartesian coordinates in given LS plane
	float u[6]; // thermal parameters
	float uiso; // isotropci thermal parameter
	float occ; // ocupancy
	int atm_number; // atom number in preiodic table
	int atm_label_number;  // atom number in the structure
	} AtomDescription;

	typedef struct{
	long nBond;
	int nIndex[MAXBONDS][2];
	} ConectivityMatrix;

	typedef struct{
	int Natoms;
	AtomDescription a[MAXATOMS];
	ConectivityMatrix bond;
	// lattice parameters, symetry e.t.c could be added later
	} StructureDescription;

#endif
