#ifndef __VOXELPROCESING
	#define __VOXELPROCESING

#include <mcube_bourke.h>
#include <msquare_mh.h>

	// coresponding to 20 Mb of memory in float 3D field
	#define MAX_VOXEL_DIMENSION  150
	#define MAXTRIANGLES 50000 
	#define MAXCONTOURLINES  100000

	typedef struct{
	float Start;
	float Step;
	float End;
	float Division;
	} AxisDescription;


	typedef struct {
	char strMapFileName[255];
	float PlaneMatrix[3][3];
	float PlaneTranslation[3];
	float Cell[6];
	AxisDescription AxisParam[3];
	int Lines;
	int Columns;
	int Sections;
	float maximum;
	float minimum;
	// very non elegant non dynamic definition, but fast ...

	float Voxel[MAX_VOXEL_DIMENSION][MAX_VOXEL_DIMENSION][MAX_VOXEL_DIMENSION];
	// atom field could be adied
	} ELD_MapData;

void GenerateTrianglesFromVoxels(unsigned int *g_iNtriangles,
								 ELD_MapData *MapData,
								 float layer_limits[3],
								 TRIANGLE triangles[3][MAXTRIANGLES]);

void VoxelDirectionalContour(unsigned int *iNcontourlines,
							 ELD_MapData *MapData,
							 float layer_limits[3],
							 LINE	contourlines[3][MAXCONTOURLINES],
							 contour_direction direction);

void SetLayerLimits(float zero,float step,float *layer_limits,ELD_MapData *MapData);

XYZ Coord3DfToInd(float x,float y,float z,ELD_MapData *MapData);


#endif
